<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

## defaults

Defaults & options

Returns **[object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** Typed defaults & options

### strings

**Properties**

-   `strings` **[array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)** strings to be typed
-   `stringsElement` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** ID of element containing string children

### typeSpeed

**Properties**

-   `typeSpeed` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** type speed in milliseconds

### startDelay

**Properties**

-   `startDelay` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** time before typing starts in milliseconds

### backSpeed

**Properties**

-   `backSpeed` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** backspacing speed in milliseconds

### smartBackspace

**Properties**

-   `smartBackspace` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** only backspace what doesn't match the previous string

### shuffle

**Properties**

-   `shuffle` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** shuffle the strings

### backDelay

**Properties**

-   `backDelay` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** time before backspacing in milliseconds

### fadeOut

**Properties**

-   `fadeOut` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Fade out instead of backspace
-   `fadeOutClass` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** css class for fade animation
-   `fadeOutDelay` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Fade out delay in milliseconds

### loop

**Properties**

-   `loop` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** loop strings
-   `loopCount` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** amount of loops

### showCursor

**Properties**

-   `showCursor` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** show cursor
-   `cursorChar` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** character for cursor
-   `autoInsertCss` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** insert CSS for cursor and fadeOut into HTML <head>

### attr

**Properties**

-   `attr` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** attribute for typing
    Ex: input placeholder, value, or just HTML text

### bindInputFocusEvents

**Properties**

-   `bindInputFocusEvents` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** bind to focus and blur if el is text input

### contentType

**Properties**

-   `contentType` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** 'html' or 'null' for plaintext

### onComplete

All typing is complete

**Parameters**

-   `self` **[Typed](#typed)** 

### preStringTyped

Before each string is typed

**Parameters**

-   `arrayPos` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** 
-   `self` **[Typed](#typed)** 

### onStringTyped

After each string is typed

**Parameters**

-   `arrayPos` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** 
-   `self` **[Typed](#typed)** 

### onLastStringBackspaced

During looping, after last string is typed

**Parameters**

-   `self` **[Typed](#typed)** 

### onTypingPaused

Typing has been stopped

**Parameters**

-   `arrayPos` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** 
-   `self` **[Typed](#typed)** 

### onTypingResumed

Typing has been started after being stopped

**Parameters**

-   `arrayPos` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** 
-   `self` **[Typed](#typed)** 

### onReset

After reset

**Parameters**

-   `self` **[Typed](#typed)** 

### onStop

After stop

**Parameters**

-   `arrayPos` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** 
-   `self` **[Typed](#typed)** 

### onStart

After start

**Parameters**

-   `arrayPos` **[number](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number)** 
-   `self` **[Typed](#typed)** 

### onDestroy

After destroy

**Parameters**

-   `self` **[Typed](#typed)** 

## HTMLParser

TODO: These methods can probably be combined somehow
Parse HTML tags & HTML Characters

## Initializer

Initialize the Typed object

## Typed

Welcome to Typed.js!

**Parameters**

-   `elementId` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** HTML element ID _OR_ HTML element
-   `options` **[object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** options object

Returns **[object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** a new Typed object

### toggle

Toggle start() and stop() of the Typed instance

### stop

Stop typing / backspacing and enable cursor blinking

### start

Start typing / backspacing after being stopped

### destroy

Destroy this instance of Typed

### reset

Reset Typed and optionally restarts

**Parameters**

-   `restart` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)?= nser** 
